#include <WiFi.h> 
#include <HTTPClient.h> 

const char* ssid = "SK_WiFiGIGA40F7";  // 와이파이 공유기 ID
const char* password = "1712037218";   // 와이파이 공유기 비밀번호

// https://api.openweathermap.org/data/2.5/weather?q=Seoul,KR&APPID=YOUR_API_KEY
const String stpoint = "http://api.openweathermap.org/data/2.5/weather?q=";
const String city = "YOUR_CITY";    // Seoul,KR
const String endpoint = "&APPID=";
const String key = "YOUR_API_KEY";  // 66e47f22f3570e6*****************
String line = "";

void setup() {
  Serial.begin(115200);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("Connected to the WiFi network");
  get_weather();
}

void get_weather() {
  if ((WiFi.status() == WL_CONNECTED)) { //Check the current connection status
    Serial.println("Starting connection to server...");
    HTTPClient http;
    http.begin(stpoint + city + endpoint + key);       //Specify the URL
    int httpCode = http.GET();  //Make the request
    if (httpCode > 0) {         //Check for the returning code
      line = http.getString();
    }
    else {
      Serial.println("Error on HTTP request");
    }
//    Serial.println(line); // 수신한 날씨 정보 시리얼 모니터 출력
    parsing();
    http.end(); //Free the resources
  }
}

void loop() {

}

void parsing() {
  int del_index = line.indexOf(F("description"));
  line.remove(0, del_index);
  int end_index = line.indexOf(F("icon")); 
  String description;
  description = line.substring(14, end_index - 3); 
  Serial.print(F("description: ")); Serial.println(description);
  del_index = line.indexOf(F("temp"));
  line.remove(0, del_index);
  end_index = line.indexOf(F("pressure")); 
  String temp;
  temp = line.substring(6, end_index - 2); 
  Serial.print(F("temp: ")); Serial.println(temp);
  del_index = line.indexOf(F("pressure"));
  line.remove(0, del_index);
  end_index = line.indexOf(F("humidity")); 
  String pressure;
  pressure = line.substring(10, end_index - 2); 
  Serial.print(F("pressure: ")); Serial.println(pressure);
  del_index = line.indexOf(F("humidity"));
  line.remove(0, del_index);
  end_index = line.indexOf(F("temp_min")); 
  String humidity;
  humidity = line.substring(10, end_index - 2); 
  Serial.print(F("humidity: ")); Serial.println(humidity);
  line = "";
}
